version: '3.4'

services:
  db:
    image: postgres:10
    hostname: db
    container_name: db
    restart: always
    volumes:
      - postgresql:/var/lib/postgresql/data
    environment:
      POSTGRES_USER: ${MYSQL_USER}
      POSTGRES_PASSWORD: ${MYSQL_PASSWORD}
      POSTGRES_DB: ${MYSQL_DATABASE}
    networks:
      - network
  tomcat:
    image: tomcat:8
    hostname: tomcat
    container_name: tomcat
    restart: always
    ports:
      - "${TOMCAT_PORT}:8080"
    volumes:
      - webapp:/usr/local/tomcat/webapps
    depends_on:
      - msm
      - mcm
      - ib
    networks:
      - network
  ib:
    hostname: ib
    container_name: ib
    restart: always
    build:
      context: ../information-broker
      dockerfile: config/docker/Dockerfile
      args:
        PROJECT: ${PROJECT}
        API_PATH: ${API_PATH}
    ports:
      - "${IB_PORT}:5000"
    environment:
      MYSQL_DATABASE: ${MYSQL_DATABASE}
      MYSQL_USER: ${MYSQL_USER}
      MYSQL_PASSWORD: ${MYSQL_PASSWORD}
      DJANGO_ADMIN_PASSWORD: ${DJANGO_ADMIN_PASSWORD}
      DJANGO_ADMIN_USER: ${DJANGO_ADMIN_USER}
      PROJECT: ${PROJECT}
      API_PATH: ${API_PATH}
      MSM_URL: ${MSM_URL}
      MCM_URL: ${MCM_URL}
    depends_on:
      - db
    networks:
      - network
  access-manager:
    hostname: access-manager
    container_name: access-manager
    restart: always
    build:
      context: ../access-manager
      dockerfile: config/Dockerfile
    depends_on:
      - ib
    ports:
      - "80:80"
    networks:
      - network
  msm:
    hostname: msm
    container_name: msm
    build:
      context: ../market-session-manager
      dockerfile: docker/Dockerfile
      args:
        informationBrokerServerUrl: ${informationBrokerServerUrl}
        marketSessionManagerUrl: ${marketSessionManagerUrl}
        marketClearingManagerUrl: ${marketClearingManagerUrl}
        pathPostTokens: ${pathPostTokens}
        credentialUser: ${credentialUser}
        credentialPassword: ${credentialPassword}
        AllSessionsCompleteTime: ${AllSessionsCompleteTime}
        FlexSessionsBillingTime: ${FlexSessionsBillingTime}
        fixedFee: ${fixedFee}
        penalty: ${penalty}
    volumes:
      - webapp:/root/war
    networks:
      - network
  mcm:
    hostname: mcm
    container_name: mcm
    build:
      context: ../market-clearing-manager
      dockerfile: docker/Dockerfile
      args:
        informationBrokerServerUrl: ${informationBrokerServerUrl}
        marketSessionManagerUrl: ${marketSessionManagerUrl}
        pathPostTokens: ${pathPostTokens}
        credentialUser: ${credentialUser}
        credentialPassword: ${credentialPassword}
        fixedFee: ${fixedFee}
        penalty: ${penalty}
    volumes:
      - webapp:/root/war
    networks:
      - network

volumes:
  webapp:
    driver: local
  postgresql:
    driver: local

networks:
  network:
    driver: "bridge"
    driver_opts:
      com.docker.network.driver.mtu: 1400
